(**********************************)
(*  TP 5 : Cryptographie par RSA  *)
(**********************************)
 

#open "num";;
#open"big_int";;

let modN = mod_num;;
#infix "modN";;
let quoN = quo_num;;
#infix "quoN";;
let sqrt_num x = num_of_big_int (sqrt_big_int (big_int_of_num x));;

(* 0 *)


let random_num num = 
  let a = string_of_num (square_num num) in
  let n = (string_length a) / 2 in
  let b = sub_string a (n / 2) n in
  let rand = (num_of_int (random__int max_int) +/ num_of_string b) modN num in
    if rand </ zero then rand +/ num else rand;;


 
(*-------------------------*)
(*  Implémentation de RSA  *)
(*-------------------------*)


(* Outils arithmétiques *)

(* 1 *)

(* pgcd : num -> num -> num *)


(* 2 *)

(* is_prime : num -> bool *)


(* 3 *)

(* generate_prime : num -> num -> num *)


(* 4 *)

(* prime_with : num -> num *)


(* 5 *)

(* extended_pgcd : num -> num -> num * num *)


(* 6 *)

(* modular_exp : num -> num -> num -> num *)


(* Implémentation du protocole *)

type key = Private of num * num | Public of num * num;;

(* 7 *)

(* generate_keys : num -> num -> key * key *)


(* 8 *)

(* encode : key -> num -> num *)
(* decode : key -> num -> num *)


(* 9 *)

(* num_to_string : key -> string -> num  *)
(* string_to_num : num -> string *)



(*---------------------------------*)
(*  Un meilleur test de primalité  *)
(*---------------------------------*)


(* Le test de Fermat *)

(* 10 *)    

(* fermat : int -> num -> bool *)

(* Le test de Rabin-Miller *)


(* 11 *)

(* decompose : num -> num * num *)


(* 12 *)

(* rabin_miller : int -> num -> bool *)


(* 13 *)

(* new_generate_prime : num -> num -> num *)
(* new_generate_keys : num -> num -> key * key *)


(*-------------------*)
(*  Attaques de RSA  *)
(*-------------------*)


(* Algorithme naïf *)

(* 15 *)

(* factorize : num -> num list *)


(* Algorithme rho de Pollard *)

(* 16 *)

(* cycle_detect: (num -> num) -> num -> num -> bool *)


(* 17 *) 

(* rho : (num -> num) -> num -> num list *)

